/* ------------------------------------------------------------------------- */
/*   AllFix 2 T-Fix converter utility  by Dmitry Dyakonov, 2:5030/207.35     */
/* ------------------------------------------------------------------------- */

InFile=''; OutFile=''; PassPath='C:\T-FIX\PassThru'; Version='0.4'
areatag.0=0; areadesc.0=0; areapath.0=0; areagroup.0=0; areaaka.0=0
areaflags.0=0; areaann.0=0; areauplink.0=0; areadownlink.0=0; respgroup.0=0
palka.0='|'; palka.1='/'; palka.2=''; palka.3='\'; pidx=0; CRLF = '0d0a'x

say CRLF'AllFix 2 T-Fix converter utility ver' Version
say '(c)1996-97 by Dmitry Dyakonov, 2:5030/207.35'

parse arg InFile OutFile rest
if (InFile = '') then
  call Usage
if (stream(InFile,'c','open read') \= 'READY:') then 
  call EndProgram "Can't open file:" InFile
if (OutFile = '') then
  OutFile = stdout
else
  if (stream(OutFile,'c','open write') \= 'READY:') then 
    call EndProgram "Can't create/append file:" OutFile
if (rest \= '') then
  do i=1 to words(rest)
     p = word(rest, i)
     if (substr(p,1,1) \= '/') then
       PassPath = strip(p,'t','\')
     else
       if (translate(substr(p,2,1)) \= 'L') then
         call EndProgram "Unknown switch:" p
       else
         LongGroup = 1
  end
call ReadFareas
call lineout OutFile, '; 'center("",76,"")
call lineout OutFile, '; 'center("This file was created with AllFix 2 T-Fix converter" Version,76)
call lineout OutFile, '; 'center('on' DATE("W") DATE("L") TIME("C"),76)
call lineout OutFile, '; 'center("",76,""); call lineout OutFile, ";"

call SortRespGroups
if (LongGroup \= 1) then call ReAssign
call lineout OutFile, left('; AllFix group',32)'T-Fix group'CRLF''left('; ',43,'')
do i=1 to respgroup.0
  call lineout OutFile, ';' respgroup.i
end
call lineout OutFile, ';'CRLF';'CRLF

do i=1 to areatag.0
  pidx = bitand(pidx, 3) 
  call charout ,'  Writing output file  ('palka.pidx')'d2c(13); pidx = pidx + 1
  call lineout OutFile, left('',30,'=') 'T-Fix Entry' left('',34,'=')''CRLF
  call lineout OutFile, left(' Path',13) areapath.i'*.*'
  call lineout OutFile, ' Exclude'
  call lineout OutFile, left(' Area',13) areatag.i
  call lineout OutFile, left(' AKA',13) areaaka.i

  call WriteLinks left(' Uplinks',13), areauplink.i
  call WriteLinks left(' Downlinks',13), areadownlink.i

  call lineout OutFile, left(' Group',13) areagroup.i
  call lineout OutFile, left(' Comment',13) areadesc.i
  call lineout OutFile, ' Template'
  call lineout OutFile, ' Semaphore'
  call lineout OutFile, ' Exec'
  call lineout OutFile, left(' Notify',13) areaann.i
  call lineout OutFile, left(' Flags',13) areaflags.i
  call lineout OutFile, ''
end
call lineout OutFile, left('',30,'=') 'EOF T-Fix.tbl' left('',34,'=')
say '  Writing output file:  done.'
call EndProgram 'Thanks for using this program.'

/* ------------------------------------------------------------------------- */
ReadFareas:
 len = 0; line = 0; fsize = chars(InFile)
 do while(lines(InFile))
  str = linein(InFile)
  len = len + length(str) + 2; line = line +1
  call charout ,'  Reading input file: 'len*100%fsize'%'d2c(13)
  if (str = '') then iterate
  word = translate(word(str, 1))
  value = strip(substr(str, pos(':',str)+1))
  select
    when word = "NAME" | word = "TAG" then
        do
           areatag.0=areatag.0+1; i=areatag.0;       areatag.i   = word(value,1)
           areaflags.0=areaflags.0+1; i=areaflags.0; areaflags.i = '+T +D +C +S'
           areaann.0=areaann.0+1; i=areaann.0;       areaann.i   =''
           areaaka.0=areaaka.0+1; i=areaaka.0;       areaaka.i   =''
           areapath.0=areapath.0+1; i=areapath.0;    areapath.i  =''
           areagroup.0=areagroup.0+1; i=areagroup.0; areagroup.i =''
           areadesc.0=areadesc.0+1; i=areadesc.0;    areadesc.i  =''
           areauplink.i = ''; areadownlink.i = ''
        end
    when word = "DESC"  then
        do
           i = areadesc.0;  areadesc.i = strip(value)
        end
    when word = "DEST"  then
        do
           if (strip(value) = '') then
             call EndProgram CRLF" ! The field 'Dest'" "not defined in line #"line
           i = areapath.0
           if (translate(word(value,1)) = 'PASS') then
             do
                areapath.i = PassPath'\'translate(strip(substr(areatag.i,1,8)),'_','.')'\'
                areaflags.i = areaflags.i '+G'
             end
           else
             areapath.i = word(value,1)
        end
    when word = "GROUP"  then
        do
           i = areagroup.0
           if (LongGroup = 1) then
             areagroup.i = QueryLongGroup(value)
           else
             areagroup.i = QueryGroup(value)
        end
    when word = "USE"  then
        do
           i = areaaka.0; areaaka.i = word(value,1)
           if (areaaka.i = 'Aka') then areaaka.i = ''
        end
    when word = "ALLOW"  then
        do
           i = areaflags.0
           if (translate(word(value,1)) = 'YES') then
             areaflags.i = areaflags.i '+E'
           else
             areaflags.i = areaflags.i '-E'
        end
    when word = "ANNOUNCE"  then
        do
           i = areaann.0
           if (translate(word(value,1)) = 'YES') then
             areaann.i = 'defnotif.txt'
        end
    when word = "DUPE"  then
        do
           if (areaflags.0 = 0) then iterate
           i = areaflags.0
           if (translate(word(value,1)) = 'YES') then
             areaflags.i = areaflags.i '+K'
           else
             areaflags.i = areaflags.i '-K'
        end
    when word = "S" | word = "R" | word = "B" then
        do while(words(str))\=0
           parse var str word value rest
           select
             when word='S' then areadownlink.i=areadownlink.i ReduceAddr(word(value,1))
             when word='R' then areauplink.i=areauplink.i ReduceAddr(word(value,1))
             when word='B' then
                 do
                    areauplink.i   = areauplink.i ReduceAddr(word(value,1))
                    areadownlink.i = areadownlink.i ReduceAddr(word(value,1))
                 end
             otherwise nop
           end
           str = rest
        end
    otherwise NOP
  end
 end; say '  Reading input file:   done.'
return

/* ------------------------------------------------------------------------- */
ReduceAddr: procedure expose areaaka. i
 parse value areaaka.i with z1 ':' n1 '/'
 parse value arg(1) with z2 ':' n2 '/' rest
 if z1=z2 & n1=n2 then return rest
return arg(1)

/* ------------------------------------------------------------------------- */
QueryGroup: procedure expose respgroup.
 do i=1 to respgroup.0
   if word(respgroup.i,1)=word(arg(1),1) then  return d2c(i-1+65)
 end
 if (respgroup.0+1) < 25 then
   newgroup=d2c(respgroup.0+65)
 else
   newgroup='Z'
 respgroup.0=respgroup.0+1; i=respgroup.0
 respgroup.i=left(strip(arg(1)),30)''newgroup
return newgroup

/* ------------------------------------------------------------------------- */
QueryLongGroup: procedure expose respgroup.
 parse arg oldgroup
 newgroup = translate(subword(oldgroup,3),'_',' ')
 do i=1 to respgroup.0
   if word(respgroup.i,1) = word(oldgroup,1) then
     return newgroup
 end
 respgroup.0 = respgroup.0 + 1;  i = respgroup.0
 respgroup.i = left(strip(oldgroup),30)''newgroup
return newgroup

/* ------------------------------------------------------------------------- */
SortRespGroups: procedure expose respgroup.
  do i=1 to respgroup.0
    do j=i+1 to respgroup.0
      if (word(respgroup.i,1) > word(respgroup.j,1)) then
        do
           tmp = respgroup.i; respgroup.i = respgroup.j; respgroup.j = tmp
        end
    end
  end
return

/* ------------------------------------------------------------------------- */
ReAssign: procedure expose respgroup. areagroup.
  do i=1 to respgroup.0
    if i > 25 then newgroup='Z'
    else newgroup=d2c(i-1+65)
    respgroup.i=respgroup.i''newgroup
  end
  do i=1 to areagroup.0
    do j=1 to respgroup.0
      if areagroup.i = substr(respgroup.j,length(respgroup.j)-1,1) then
        do
          areagroup.i = substr(respgroup.j,length(respgroup.j),1)
          leave
        end
    end
  end
  do i=1 to respgroup.0
    newgroup=substr(respgroup.i,length(respgroup.i),1)
    respgroup.i=substr(respgroup.i,1,length(respgroup.i)-2)''newgroup
  end
return

/* ------------------------------------------------------------------------- */
WriteLinks:
 parse arg keyword, links
 links = strip(links); str = links;
 if length(links) < 480 then
   do
      call lineout OutFile, keyword links
      return
   end
 do while length(links) > 480
   p = 'z'; k = 480
   do while(p \= ' '  &  k > 0)
     links = substr(str,k)
     p = substr(links,1,1)
     k = k - 1
   end
   if (k = 0) then 
     links = substr(str,1,480)
   else
     links = substr(str,1,k)
   call lineout OutFile, keyword links
   if (k = 0) then
     links = substr(str,480+1)
   else
     links = substr(str,k+2)
   str = links
 end  
 call lineout OutFile, keyword links
return

/* ------------------------------------------------------------------------- */
Usage:
say CRLF'Usage:'CRLF'       af2tf.cmd <infile> <outfile> [passthrough dir] [/l]'
say CRLF'Example:'CRLF'       af2tf.cmd fareas.txt t-fix.tbl e:\passthru'
call EndProgram ''
return

/* ------------------------------------------------------------------------- */
EndProgram:
 say Arg(1)
 exit
return

/* ------------------------[ End of af2tf.cmd ]----------------------------- */
